; The Construct v1.0
; Effusive
;
; Credits go out to...
;    Trig Identities  -- Adam Martin
;      For most of the code structure
;    AP Calc AB -- Terrence Wong
;      For text in the calculus categories
;    AP Physics B Formulas -- Xexix
;      For various physics formulas
;    Takalah's AP Calculus Website
;      For a good guide on equation balancing

; Include files for the Ti-86
#include "ti86asm.inc"
#include "ti86ops.inc"
.org _asm_exec_ram
	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

; Assembly shell title and other smaller 'ASCII' graphics
ShellTitle:
	.db "Math Construct - Effusive",0
Title:
    .db " - [Math Construct] - [Effusive] -",0
keys:
	.db "      ",6,"  ",7," move    ENTER   select     EXIT   quit",0
; Our menu titles
line1:
	.db " Algebraic   Properties",0
line2:
	.db " Geometric   Formulas",0
line3:
	.db " Trigonometric   Identities",0
line4:
	.db " Basic   Calculus   and   Derivatives",0
line5:
	.db " Integral   Calculus",0
line6:
	.db " Physics  and  Chemistry",0
line7:
    .db " Other   Laws   and   Formulas",0
; Algebraic Properties (4 screens)
Recip1:
	.db " Reflexive :   a = a",0
Recip2:
	.db " Symmetric :   a = b   so   b = a",0
Recip3:
	.db " Transitive :   a = b,  b = c   so   a = c",0
Recip4:
	.db " Commutative :   a+b = b+a,  ab = ba",0
Recip5:
	.db " Distributive :   a(b+c) = ab+ac",0
Recip6:
	.db " Identity :   1a = a,  0a = 0,  a+0 = a",0
Recip7:
    .db " Associative :   (a+b)+c = a+(b+c)",0
Recip1b:
    .db " Associative :   (ab)c = a(bc)",0
Recip2b:
    .db " Various   Exponent/Root   Laws...",0
Recip3b:
    .db "  a^x*a^y = a^(x+y), (ab)^x = a^x*b^x",0
Recip4b:
    .db "  (a^x)^y = a^(xy), a^x/a^y=a^(x-y)",0
Recip5b:
    .db "  When   a",24,"0:  a^0=1,  a^(-x)=1/(a^x)",0
Recip6b:
    .db "  (a/b)^x=a^x/b^x,  a^(x/y)=y",205,16,"(a^x)",0
Recip7b:
    .db "  ",16,"(ab)=",16,"a*",16,"b,     ",16,"(a/b)=",16,"a/",16,"b",0
Recip1c:
    .db " Log   is   base   10,  ln   is   base   e.",0
Recip2c:
    .db " Logb   represents   any   base   number.",0
Recip3c:
    .db "  logb b=1,  logb 1=0,  ln x=log x/log e",0
Recip4c:
    .db "  logb x=y <-> b^y=x",0
Recip5c:
    .db "  logb (a^x)=x logb a",0
Recip6c:
    .db "  logb ax=logb a+logb x",0
Recip7c:
    .db "  logb (a/x)=logb a-logb x",0
Recip1d:
    .db " nPr=n!/(n-r)!         nCr=n!/r!(n-r)!",0
Recip2d:
    .db " (a+b)^n =",0
Recip3d:
    .db "   n",0
Recip4d:
    .db "   ",198," nCr * a^(n-r) * b^r",0
Recip5d:
    .db "  r=0",0
Recip6d:
    .db " Vertex of a quadratic: (x,y)",0
Recip7d:
    .db "  (-b/2a), (c-(b",Lsquare,"/4a))",0
; Geometric Formulas (5 screens)
Q1:
	.db " General:  Ax+By=C",0
Q2:
	.db " SlopeInt:  y=mx+b  or  y=(-A/B)x+(C/B)",0
Q3:
    .db " Point Slope Equation:  y-y1=m(x-x1)",0
Q4:
    .db " Slope = (y2-y1)/(x2-y1)",0
Q5:
    .db " Distance=",16,"((x2-x1)",Lsquare,"+(y2-y1)",Lsquare,")",0
Q6:
    .db " Midpoint=((x1+x2)/2,(y1+y2)/2)",0
Q7:
    .db " f(x)=n is the same as f:x->n",0
Q1b:
    .db " Circles:",0
Q2b:
    .db "   x",Lsquare,"+y",Lsquare,"=r",Lsquare,0
Q3b:
    .db "   (x-h)",Lsquare,"+(y-k)",Lsquare,"=r",Lsquare,0
Q4b:
    .db " Rotation Equations:",0
Q5b:
    .db "   x' = x cos ",193," + y sin ",193,0
Q6b:
    .db "   y' = y cos ",193," - x sin ",193,0
Q7b:
    .db " Variation: Direct: y=kx   Inverse: y=k/x",0
Q1c:
    .db " Ellipse:",0
Q2c:
    .db "  Vertical major axis --",0
Q3c:
    .db "   (x",Lsquare,"/b",Lsquare,")+(y",Lsquare,"/a",Lsquare,")=1",0
Q4c:
    .db "   ((x-h)",Lsquare,"/b",Lsquare,")+((y-k)",Lsquare,"/a",Lsquare,")=1",0
Q5c:
    .db "  Horizontal major axis --",0
Q6c:
    .db "   (x",Lsquare,"/a",Lsquare,")+(y",Lsquare,"/b",Lsquare,")=1",0
Q7c:
    .db "   ((x-h)",Lsquare,"/a",Lsquare,")+((y-k)",Lsquare,"/b",Lsquare,")=1",0
Q1d:
    .db " Hyperbola:",0
Q2d:
    .db "  Vertical transverse axis --",0
Q3d:
    .db "   (y",Lsquare,"/a",Lsquare,")-(x",Lsquare,"/b",Lsquare,")=1",0
Q4d:
    .db "   ((y-k)",Lsquare,"/a",Lsquare,")+((x-h)",Lsquare,"/b",Lsquare,")=1",0
Q5d:
    .db "  Horizontal transverse axis --",0
Q6d:
    .db "   (x",Lsquare,"/a",Lsquare,")-(y",Lsquare,"/b",Lsquare,")=1",0
Q7d:
    .db "   ((x-h)",Lsquare,"/a",Lsquare,")-((y-k)",Lsquare,"/b",Lsquare,")=1",0
Q1e:
    .db " Parabola:",0
Q2e:
    .db "  Vertical, Horizontal Axis --",0
Q3e:
    .db "   x",Lsquare,"=4ay   (x-h)",Lsquare,"=4a(y-k)",Lsquare,0
Q4e:
    .db "   y",Lsquare,"=4ax   (y-k)",Lsquare,"=4a(x-h)",Lsquare,0
Q5e:
    .db " Perpendicular Slope = -1/m",0
Q6e:
    .db " |x|>b: x<-b or x>b,  |x|<b: -b<x<b",0
; Trigonometric Identities (5 screens)
Trigg1:
    .db "Reciprocal Identities",0
Trigg2:
	.db "   sin x = 1/(csc x)",0
Trigg3:
	.db "   sec x = 1/(cos x)",0
Trigg4:
	.db "   tan x = 1/(cot x)",0
Trigg5:
	.db "   csc x = 1/(sin x)",0
Trigg6:
	.db "   cos x = 1/(sec x)",0
Trigg7:
	.db "   cot x = 1/(tan x)",0
Trigg1b:
    .db "Quotient Identities",0
Trigg2b:
	.db "   tan x = (sin x)/(cos x)",0
Trigg3b:
	.db "   cot x = (cos x)/(sin x)",0
Trigg4b:
    .db "Pythagorean Identities",0
Trigg5b:
	.db "   sin",Lsquare," x   +   cos",Lsquare," x = 1",0
Trigg6b:
	.db "   1   +   tan",Lsquare," x = sec",Lsquare," x",0
Trigg7b:
	.db "   1   +   cot",Lsquare," x = csc",Lsquare," x",0
Trigg1c:
	.db "Cofunction Identities",0
Trigg2c:
	.db "   sin (",Lpi,"/2 - x) = cos x",0
Trigg3c:
	.db "   cos (",Lpi,"/2 - x) = sin x",0
Trigg4c:
	.db "   csc (",Lpi,"/2 - x) = sec x",0
Trigg5c:
	.db "   tan (",Lpi,"/2 - x) = cot x",0
Trigg6c:
	.db "   sec (",Lpi,"/2 - x) = csc x",0
Trigg7c:
	.db "   cot (",Lpi,"/2 - x) = tan x",0
Trigg1d:
    .db "Even-Odd Identities",0
Trigg2d:
	.db "   sin(-x) = -sin x",0   
Trigg3d:
	.db "   cos(-x) = cos x",0
Trigg4d:
	.db "   csc(-x) = -csc x",0
Trigg5d:
	.db "   tan(-x) = -tan x",0
Trigg6d:
	.db "   sec(-x) = sec x",0
Trigg7d:
	.db "   cot(-x) = -cot x",0
Trigg1e:
	.db "   sin 2x = 2 sin x cos x",0
Trigg2e:
    .db "Double-Angle Identities",0
Trigg3e:
	.db "   cos 2x = cos",Lsquare," x - sin",Lsquare," x ",0
Trigg4e:
	.db "   cos",Lsquare," x - sin",Lsquare," x = 2 cos",Lsquare," x - 1",0
Trigg5e:
	.db "   2 cos",Lsquare," x - 1 = 1 - 2 sin",Lsquare," x",0
Trigg6e:
	.db "   tan 2x = (2 tan x)/(1 - tan",Lsquare," x)",0
; Differential Calculus
Cof1:
	.db "As f(x) approaches infinity does it go",0
Cof2:
	.db "to a number but not cross it?",0
Cof3:
	.db "x/x",18," approaches 0 (horiz asymptote)",0
Cof4:
	.db "There is usually a vertical asymptote",0
Cof5:
	.db "when the denominator is zero.",0
Cof1b:
    .db "f(x) is continuous at a point c when:",0
Cof2b:
    .db " 1. It is defined at c.",0
Cof3b:
    .db " 2. lim f(x) exists.",0
Cof4b:
    .db "      x->c",0
Cof5b:
    .db " 3. f(c)=lim f(c)",0
Cof6b:
    .db "                       x->c",0
Cof1c:
    .db " lim  f(x)/g(x)",0
Cof2c:
    .db "x->a",0
Cof3c:
    .db "Evaluate at a if real. Use factoring",0
Cof4c:
    .db "and algebra to reduce so demoninator",0
Cof5c:
    .db "won't be 0. If you plug 0 into the equ and",0
Cof6c:
    .db "get 0/0 then it is        lim f'(x)/g'(x)",0
Cof7c:
    .db "reducible: Use            x->a",0
Cof1d:
	.db "       lim          f(x)/g(x)",0
Cof2d:
	.db "x->infinity",0
Cof3d:
    .db "Compare degrees of leading exponents:",0
Cof4d:
    .db "4x",Lsquare,"/6x",Lsquare,"                 = Ratio 4/6",0
Cof5d:
    .db "4x^100/6x^5 = Infinity or doesn't exist",0
Cof6d:
    .db "4x^5/6x^100 = Zero",0
Cof1e:
    .db "The derivative is the tangent line slope.",0
Cof2e:
    .db "dy/dx = lim   f(x+h)-f(x) / h",0
Cof3e:
    .db "                        h->0",0
Cof4e:
    .db "Is the deriative of f(x) [y] with respect",0
Cof5e:
    .db "to x [dy/dx].    I.e.   6x",Lsquare,5,"12x",0
Cof6e:
    .db "Next screen will show common derivs.",0
Cof1f:
    .db "sin",5,"cos       csc",5,"-csc*cot       cos",5,"-sin",0
Cof2f:
    .db "sec",5,"sec*tan       tan",5,"sec",Lsquare,0
Cof3f:
    .db "cot",5,"-csc",Lsquare,"       ln x",5,"1/x",0
Cof4f:
    .db "e^x",5,"e^x         a(x^b)",5,"ab(x^(b-1))",0
Cof5f:
    .db "a^x",5,"a^x*(ln a)         kx",5,"k",0
Cof6f:
    .db "k",5,"0         ",16,"x",5,"(1/2)x^(-1/2)",0
Cof7f:
    .db "x",5,"1         f(x)",5,"f'(x)        f'(x)",5,"f''(x)",0
Cof1g:
	.db "Lengths of:",0
Cof2g:
	.db "  Subtang=|y1/m|    Subnorm=|m*y1|",0
Cof3g:
	.db "  Tangent=|(y1*",16,"(1+m",Lsquare,"))/m|",0
Cof4g:
	.db "  Normal=|y1*",16,"(1+m",Lsquare,")|",0
Cof5g:
	.db "Angle between two curves:",0
Cof6g:
	.db "  Angle between tangents 1 and 2:",0
Cof7g:
    .db "    = (m2-m1)/(1+m1*m2)",0
; Integral Calculus
EO1:
	.db "The area under the curve bounded",0
EO2:
	.db "by the integral. It tells the sum",0
EO3:
	.db "of all the changes of the function",0
EO4:
	.db "before it.",0
EO5:
	.db "o",Lintegral,Lcube," f(x)dx = F(3)-F(0)",0
EO6:
    .db "F(x) is the anti-derivative of f(x).",0
EO7:
    .db "F'(x) = f(x)",0
EO1b:
    .db "To solve, take the anti-derivative",0
EO2b:
    .db "of the integrand and add a constant.",0
EO4b:
    .db Lintegral,"x = (1/2)x",Lsquare," + C",0
; Physics and Chem
Phc1:
	.db "Uniform Motion",0
Phc2:
	.db "   v, avg=",LcapDelta,"x/",LcapDelta,"t",0
Phc3:
	.db "   a, avg=",LcapDelta,"v/",LcapDelta,"t",0
Phc4:
	.db "   vf=vo+at",0
Phc5:
	.db "   ",LcapDelta,"s=vot+(1/2)at",Lsquare,0
Phc6:
	.db "   v, avg=(vo+vf)/2",0
Phc7:
	.db "   ",LcapDelta,"s=((vo+vf)/2)t",0
Phc1b:
	.db "   ",LcapDelta,"s=(vf",Lsquare,"-vo",Lsquare,")/(2a)",0
Phc2b:
	.db "   a=(vf",Lsquare,"-vo",Lsquare,")/(2",LcapDelta,"s)",0
Phc3b:
	.db "   vf",Lsquare,"=vo",Lsquare,"+2a",LcapDelta,"s",0
Phc4b:
	.db "Torque",0
Phc5b:
	.db "   ",Ltau,"=rF sin ",Ltheta,0
Phc6b:
	.db "   ",Ltau,"=mar",0
Phc7b:
	.db "   ",Ltau,"=mvr/t",0
Phc1c:
	.db "Planetary Motion",0
Phc2c:
	.db "   K,s=R?/T",Lsquare,0
Phc3c:
	.db "   F,g=Gm1m2/R",Lsquare,0
Phc4c:
	.db "   a=Gm/R",Lsquare,"     U,g=Gm1m2/R",0
Phc5c:
	.db "   R?/T",Lsquare,"=Gm/4",Lpi,Lsquare,0
Phc6c:
	.db "   v,esc=",16,"(2Gm/R)",0
Phc7c:
	.db "   v,orbit=",16,"(Gm/R)",0
Phc1d:
	.db "Momentum",0
Phc2d:
	.db "   P=mv      J=F",LcapDelta,"t",0
Phc3d:
	.db "   J=",LcapDelta,"P",0
Phc4d:
	.db "   m1v1+m2v2=m1v1'+m2v2'",0
Phc5d:
	.db "Oscillations",0
Phc6d:
	.db "   a=-kx/m        T,s=2",Lpi,16,"(m/k)",0
Phc7d:
	.db "   T,p=2",Lpi,16,"(length/g)",0
Phc1e:
	.db "Forces",0
Phc2e:
	.db "   ",LcapSigma,"F=ma      W=mg",0
Phc3e:
	.db "   F,s=-kx  f,fric",LLE,Lmu,"N",0
Phc4e:
	.db "   F,c=mv",Lsquare,"R",0
Phc5e:
	.db "Nuclear",0
Phc6e:
	.db "   E=hv=pc    K,max=hv-",Ltheta,0
Phc7e:
	.db "   ",Llambda,"=h/p    ",LcapDelta,"E=",LcapDelta,"m*c",Lsquare,0
Phc1x:
	.db "Basic Units                Tesla kg/(a*s",Lsquare,")",0
Phc2x:
	.db "   Ampere  C/s     Newton  kg*m/s",Lsquare,0
Phc3x:
	.db "   Pascal  kg/(m*s",Lsquare,")    Joule  kg*m",Lsquare,"/s",Lsquare,0
Phc4x:
	.db "   Watt  kg*m",Lsquare,"/s?    Volt  kg*m",Lsquare,"/(A*s?)",0
Phc5x:
	.db "   Ohm  kg*m",Lsquare,"/(A",Lsquare,"*s?)    Weber T*m",Lsquare,0
Phc6x:
	.db "   Henry  kg*m",Lsquare,"/(A",Lsquare,"*s",Lsquare,")",0
Phc7x:
	.db "   Farad  A",Lsquare,"*s^4/(kg*m",Lsquare,")",0
Phc1y:
	.db "Balancing Equations Guide:",0
Phc2y:
	.db "1. Check if it all adds up!",0
Phc3y:
	.db "2. Start your balancing with the atom",0
Phc4y:
	.db "that is combined with another on both",0
Phc5y:
	.db "sides, and has the most atoms.",0
Phc6y:
	.db "3. Leave the solitary atoms til last.",0
Phc7y:
	.db "4. Don't change the formula!!!!",0
; Misc
DA1:
	.db "Compound Interest:  An=P(1+r)^n",0
DA2:
	.db "Simple Interest:  i=prt",0
DA3:
	.db "Present Value:  P=((1+r)^-n)*A",0
DA4:
	.db "Arithmetic Sequence:",0
DA5:
	.db "  An=A1+d(n-1)   Sn=.5n(A1+An)",0
DA6:
    .db "Geometric Sequence:",0
DA7:
    .db "  An=A1*r^(n-1)   Sn=A1((1-r^n)/(1-r))",0
DA1b:
    .db "Basic Matrix Operations:",0
DA2b:
    .db "x[a b] = [ax ab]    [a b]+[c d]=[a+b c+d]",0
DA3b:
	.db "Transpose = Rows to columns in order.",0
DA4b:
    .db "(A",Ltranspose,")",Ltranspose,"=A   (AB)",Ltranspose,"=B",Ltranspose,"A",Ltranspose,0
DA5b:
    .db "(A+B)",Ltranspose,"=A",Ltranspose,"+B",Ltranspose,"   (kA)",Ltranspose,"=kA",Ltranspose,0
DA6b:
    .db "AA",Linverse,"=A",Linverse,"A=I   I=1's along ",Lbackslash,", 0's elsewhere",0
DA7b:
    .db "Size=Num of rows X Num of columns",0
DA1c:
    .db "A union B = {x:x",Lepsilon,"A or x",Lepsilon,"B}",0
DA2c:
	.db "A intersection B = {x:x",Lepsilon,"A,x",Lepsilon,"B}",0
DA3c:
	.db Lphi,"={}    This is called the null set.",0
DA4c:
	.db "x",Lepsilon,"A <-> A contains x",0
DA5c:
	.db "Ac={x:x",Lepsilon,"U,x is not in A}",0
DA6c:
	.db "A",Lbackslash,"B={x:x",Lepsilon,"A,x is not in B}",0
DA7c:
	.db "A(+)B=(A",Lbackslash,"B) union (B",Lbackslash,"A)",0
PressEnter:
	.db "                                 "
	.db "     Press   Enter !",0
OutP1:
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ret
OutP2:
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ret
OutP3:
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ret
OutP4:
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ret
OutP5:
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ret
OutP6:
	call _vputs
	ld hl,$3100
	ld (_penCol),hl
	ret
OutP7:
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ret
ProgStart:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,Title
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,line1
    call OutP1
    ld hl,line2
	call OutP2
	ld hl,line3
	call OutP3
	ld hl,line4
	call OutP4
	ld hl,line5
	call OutP5
	ld hl,line6
	call OutP6
	ld hl,line7
	call OutP7
	ld hl,keys
	call _vputs
	call B7Black
	ld c,7
DoMenuDTL:
	ld a,d								;Get The Vertical Coord
	add a,7								;Move To Next Line
	ld d,a								;Save New Coord
	djnz DoMenuDTL						;Draw All The Text
	ld b,1								;Start Menu At First Entry
	call DoMenuInvBar					;Invert It
DoMenuL:
	push bc								;Save Entries And Current Entry
	call _getky						 	;Read Key Presses
	pop bc								;Restore It
	cp K_UP								;Did They Press Up?
	jr z,DoMenuUp						;Move Menu Bar Up
	cp K_EXIT
	jp z,Exit
	cp K_DOWN							;Or Was It Down?
	jr z,DoMenuDown
	cp K_ENTER
	jr z,WhichIdentity
	jr DoMenuL							;They're Just Sitting There, Loop Again
DoMenuUp:
	call DoMenuInvBar					;Invert Current Selection Back To Normal
	dec b								;Move Up
	jr nz,DoMenuBar
	ld b,7
	jr DoMenuBar						;Handle Menu Bar
DoMenuDown:
	call DoMenuInvBar					;Same As Up, Go Back To Normal Text
	ld a,c
	cp b								;At The Bottom?
	jr z,DoMenuDownT					;Then Move To The Top								;Get Current Entry For Check
	inc b								;Move Down
	jr DoMenuBar						;Handle Menu Bar
DoMenuDownT:
	ld b,1								;Move To The Top
DoMenuBar:
	call DoMenuInvBar					;Invert The New Selection
	jr DoMenuL							;Now It's Time To Loop
DoMenuInvBar:
	push bc								;Save Position And Entries
	ld h,b								;Get Position
	ld l,112							;There Are 7 Lines Of 16 Bytes Each (7*16 = 112)
	call _HtimesL						;Do The Multiply
	ld de,$fc00 							;We Need To Add To Video Memory
	add hl,de							;Do The Add
	call DoMenuInv						;Invert The Line
	pop bc								;Restore Position And Entries
	ret									;Done Inverting
DoMenuInv:
	ld b,7*16							;Each Row Is 16 Bytes Wide And Text Is 7 Rows High
DoMenuIL:
	ld a,(hl)							;Get The Byte
	cpl						 			;NOT The Byte--Flips All The Bits
	ld (hl),a							;Save The New Byte
	inc hl								;Next Byte
	djnz DoMenuIL						;Loop For All Bytes
	ret						 			;We're Done With The Invert Loop
Exit:
	call _clrLCD
	call _homeup
	ret
Top7Invert:
	call _clrLCD
	ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,111
    ldir
    set  3,(iy+05)
    ld   de,$0001
    ld   (_penCol),de
    ret
Drw:
    call _vputs
    res  3,(iy+05)
	ret
B7Black:
    ld b,112
    ld hl,$FF90
Draw1:
    ld a,(hl)
    cpl
    ld (hl),a
    inc	hl
    djnz Draw1
	ret
WhichIdentity:
	ld a,1
	cp b
	jp z,Reciprocal
	inc a
	cp b
	jp z,Quotient
	inc a
	cp b
	jp z,Pythagorean
	inc a
	cp b
	jp z,Cofunction
	inc a
	cp b
	jp z,EvenOdd
    inc a
    cp b
    jp z,PhysicsChem
	jp nz,DblAngles
Reciprocal:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line1
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Recip1
	call OutP1
	ld hl,Recip2
	call OutP2
	ld hl,Recip3
	call OutP3
	ld hl,Recip4
	call OutP4
	ld hl,Recip5
	call OutP5
	ld hl,Recip6
	call OutP6
	ld hl,Recip7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line1
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Recip1b
	call OutP1
	ld hl,Recip2b
	call OutP2
	ld hl,Recip3b
	call OutP3
	ld hl,Recip4b
	call OutP4
	ld hl,Recip5b
	call OutP5
	ld hl,Recip6b
	call OutP6
	ld hl,Recip7b
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line1
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Recip1c
	call OutP1
	ld hl,Recip2c
	call OutP2
	ld hl,Recip3c
	call OutP3
	ld hl,Recip4c
	call OutP4
	ld hl,Recip5c
	call OutP5
	ld hl,Recip6c
	call OutP6
	ld hl,Recip7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line1
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Recip1d
	call OutP1
	ld hl,Recip2d
	call OutP2
	ld hl,Recip3d
	call OutP3
	ld hl,Recip4d
	call OutP4
	ld hl,Recip5d
	call OutP5
	ld hl,Recip6d
	call OutP6
	ld hl,Recip7d
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Quotient:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1
	call OutP1
	ld hl,Q2
	call OutP2
	ld hl,Q3
	call OutP3
	ld hl,Q4
	call OutP4
	ld hl,Q5
	call OutP5
	ld hl,Q6
	call OutP6
	ld hl,Q7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1b
	call OutP1
	ld hl,Q2b
	call OutP2
	ld hl,Q3b
	call OutP3
	ld hl,Q4b
	call OutP4
	ld hl,Q5b
	call OutP5
	ld hl,Q6b
	call OutP6
	ld hl,Q7b
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1c
	call OutP1
	ld hl,Q2c
	call OutP2
	ld hl,Q3c
	call OutP3
	ld hl,Q4c
	call OutP4
	ld hl,Q5c
	call OutP5
	ld hl,Q6c
	call OutP6
	ld hl,Q7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1d
	call OutP1
	ld hl,Q2d
	call OutP2
	ld hl,Q3d
	call OutP3
	ld hl,Q4d
	call OutP4
	ld hl,Q5d
	call OutP5
	ld hl,Q6d
	call OutP6
	ld hl,Q7d
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line2
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Q1e
	call OutP1
	ld hl,Q2e
	call OutP2
	ld hl,Q3e
	call OutP3
	ld hl,Q4e
	call OutP4
	ld hl,Q5e
	call OutP5
    ld hl,$3100
	ld (_penCol),hl
	ld hl,Q6e
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Pythagorean:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Trigg1
	call OutP1
	ld hl,Trigg2
	call OutP2
	ld hl,Trigg3
	call OutP3
	ld hl,Trigg4
	call OutP4
	ld hl,Trigg5
	call OutP5
	ld hl,Trigg6
	call OutP6
	ld hl,Trigg7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Trigg1b
	call OutP1
	ld hl,Trigg2b
	call OutP2
	ld hl,Trigg3b
	call OutP3
	ld hl,Trigg4b
	call OutP4
	ld hl,Trigg5b
	call OutP5
	ld hl,Trigg6b
	call OutP6
	ld hl,Trigg7b
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Trigg1c
	call OutP1
	ld hl,Trigg2c
	call OutP2
	ld hl,Trigg3c
	call OutP3
	ld hl,Trigg4c
	call OutP4
	ld hl,Trigg5c
	call OutP5
	ld hl,Trigg6c
	call OutP6
	ld hl,Trigg7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Trigg1d
	call OutP1
	ld hl,Trigg2d
	call OutP2
	ld hl,Trigg3d
	call OutP3
	ld hl,Trigg4d
	call OutP4
	ld hl,Trigg5d
	call OutP5
	ld hl,Trigg6d
	call OutP6
	ld hl,Trigg7d
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line3
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Trigg1e
	call OutP1
	ld hl,Trigg2e
	call OutP2
	ld hl,Trigg3e
	call OutP3
	ld hl,Trigg4e
	call OutP4
	ld hl,Trigg5e
	call OutP5
	ld hl,Trigg6e
	call OutP6
    ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
Cofunction:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1
	call OutP1
	ld hl,Cof2
	call OutP2
	ld hl,Cof3
	call OutP3
	ld hl,Cof4
	call OutP4
	ld hl,Cof5
	call OutP5
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1b
	call OutP1
	ld hl,Cof2b
	call OutP2
	ld hl,Cof3b
	call OutP3
	ld hl,Cof4b
	call OutP4
	ld hl,Cof5b
	call OutP5
	ld hl,Cof6b
	call OutP6
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1c
	call OutP1
	ld hl,Cof2c
	call OutP2
	ld hl,Cof3c
	call OutP3
	ld hl,Cof4c
	call OutP4
	ld hl,Cof5c
	call OutP5
	ld hl,Cof6c
	call OutP6
	ld hl,Cof7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1d
	call OutP1
	ld hl,Cof2d
	call OutP2
	ld hl,Cof3d
	call OutP3
	ld hl,Cof4d
	call OutP4
	ld hl,Cof5d
	call OutP5
	ld hl,Cof6d
	call OutP6
	ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1e
	call OutP1
	ld hl,Cof2e
	call OutP2
	ld hl,Cof3e
	call OutP3
	ld hl,Cof4e
	call OutP4
	ld hl,Cof5e
	call OutP5
	ld hl,$3100
	ld (_penCol),hl
	ld hl,Cof6e
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1f
	call OutP1
	ld hl,Cof2f
	call OutP2
	ld hl,Cof3f
	call OutP3
	ld hl,Cof4f
	call OutP4
	ld hl,Cof5f
	call OutP5
	ld hl,Cof6f
	call OutP6
	ld hl,Cof7f
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line4
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Cof1g
	call OutP1
	ld hl,Cof2g
	call OutP2
	ld hl,Cof3g
	call OutP3
	ld hl,Cof4g
	call OutP4
	ld hl,Cof5g
	call OutP5
	ld hl,Cof6g
	call OutP6
	ld hl,Cof7g
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
EvenOdd:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line5
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,EO1
	call OutP1
	ld hl,EO2
	call OutP2
	ld hl,EO3
	call OutP3
	ld hl,EO4
	call OutP4
	ld hl,EO5
	call OutP5
	ld hl,EO6
	call OutP6
	ld hl,EO7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line5
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,EO1b
	call OutP1
	ld hl,EO2b
	call _vputs
    ld hl,$1C00
	ld (_penCol),hl
	ld hl,EO4b
	call _vputs
    ld hl,$3900
	ld (_penCol),hl
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
PhysicsChem:
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1
	call OutP1
	ld hl,Phc2
	call OutP2
	ld hl,Phc3
	call OutP3
	ld hl,Phc4
	call OutP4
	ld hl,Phc5
	call OutP5
	ld hl,Phc6
	call OutP6
	ld hl,Phc7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1b
	call OutP1
	ld hl,Phc2b
	call OutP2
	ld hl,Phc3b
	call OutP3
	ld hl,Phc4b
	call OutP4
	ld hl,Phc5b
	call OutP5
	ld hl,Phc6b
	call OutP6
	ld hl,Phc7b
	call OutP7
	ld hl,PressEnter
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1c
	call OutP1
	ld hl,Phc2c
	call OutP2
	ld hl,Phc3c
	call OutP3
	ld hl,Phc4c
	call OutP4
	ld hl,Phc5c
	call OutP5
	ld hl,Phc6c
	call OutP6
	ld hl,Phc7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1d
	call OutP1
	ld hl,Phc2d
	call OutP2
	ld hl,Phc3d
	call OutP3
	ld hl,Phc4d
	call OutP4
	ld hl,Phc5d
	call OutP5
	ld hl,Phc6d
	call OutP6
	ld hl,Phc7d
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1e
	call OutP1
	ld hl,Phc2e
	call OutP2
	ld hl,Phc3e
	call OutP3
	ld hl,Phc4e
	call OutP4
	ld hl,Phc5e
	call OutP5
	ld hl,Phc6e
	call OutP6
	ld hl,Phc7e
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1x
	call OutP1
	ld hl,Phc2x
	call OutP2
	ld hl,Phc3x
	call OutP3
	ld hl,Phc4x
	call OutP4
	ld hl,Phc5x
	call OutP5
	ld hl,Phc6x
	call OutP6
	ld hl,Phc7x
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD	
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line6
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,Phc1y
	call OutP1
	ld hl,Phc2y
	call OutP2
	ld hl,Phc3y
	call OutP3
	ld hl,Phc4y
	call OutP4
	ld hl,Phc5y
	call OutP5
	ld hl,Phc6y
	call OutP6
	ld hl,Phc7y
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
DblAngles: 
	call _clrLCD
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line7
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,DA1
	call OutP1
	ld hl,DA2
	call OutP2
	ld hl,DA3
	call OutP3
	ld hl,DA4
	call OutP4
	ld hl,DA5
	call OutP5
	ld hl,DA6
	call OutP6
	ld hl,DA7
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line7
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,DA1b
	call OutP1
	ld hl,DA2b
	call OutP2
	ld hl,DA3b
	call OutP3
	ld hl,DA4b
	call OutP4
	ld hl,DA5b
	call OutP5
	ld hl,DA6b
	call OutP6
	ld hl,DA7b
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	call _clrLCD
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,line7
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,DA1c
	call OutP1
	ld hl,DA2c
	call OutP2
	ld hl,DA3c
	call OutP3
	ld hl,DA4c
	call OutP4
	ld hl,DA5c
	call OutP5
	ld hl,DA6c
	call OutP6
	ld hl,DA7c
	call OutP7
	ld hl,PressEnter	
	call _vputs
	call B7Black
	call _pause
	jp ProgStart
.message "Math Construct By Effusive"
.end
